package blackjack;


// Player has all the attributed of a dealer
// + account and split hand
public class Player extends Dealer{

	public int splitHand[] = new int[11];
	public int account;
	public String playerName;
	public String splitHandString;
	public boolean canSplit = false;
	public boolean didSplit = false;
	public boolean canHitSplit = false;
	public boolean bankrupt = false;
	public boolean doubleDown = false;
	public boolean canInsure = false;
	public boolean didInsure = false;

	





		
	// Default constructor
	public Player(){

		// Player initialized with 100$ in his account
		this.account = 100;
	}

	// Method to get paid
	public int getPaid(int amount){
		this.account = this.account + amount;
		return this.account;
	}
	
	// Method to deduct account
	public void deductAcct(){
		this.account = this.account - 10;
	}
	
	// Method to split
	public void split(){
		if(this.hand[0] == this.hand[1] && this.hand[2] == 0){
			this.splitHand[0] = this.hand[1];
			this.hand[1] = 0;
			this.deductAcct();
		}
		
	}
	
	
	// Method to 'Hit' the split hand
	public void hitSplitHand(int card){

		for(int i = 0; i < 11; i++)
			if (this.splitHand[i] == 0){
				this.splitHand[i] = card;
				this.splitHandString = stringHand(this.splitHand);
				return;
			}
	}
	
	
	// Method to reset all the cards in hand 
	// Overrides dealer's method by reseting split hand
	public void resetHand(){
		// 0 used to mark a 'no card' status
		for(int i = 0; i < 11; i++){
			this.splitHand[i] = 0;
			this.hand[i] = 0;
		}
		this.mainHand = "Empty Hand";
		this.splitHandString = "";
	}

}
