package blackjack;


import javax.swing.*;
import java.awt.Color;
import javax.swing.JTextPane;
import javax.swing.JButton;
import javax.swing.JLabel;







public class Table extends JFrame {
	
	// Declarations
	private boolean newGame = true;
	private boolean gameOver = false;
	private JDesktopPane tableTop = null;  
	private JButton rigCardButton = null;
	private JButton newGameButton = null;
	private JTextField rigCardNumber = null;
	private JLabel cardRead = null;
	private JTextField rigCardIndex = null;
	private JLabel LabelDealer = null;
	private JLabel jLabel6 = null;
	private JButton info = null;
	private JButton showDeckButton = null;
	private JLabel jLabel = null;
	private JTextField p1Name = null;
	private JTextField p2Name = null;
	private JTextField p3Name = null;
	private JButton p1Split = null;
	private JButton p2Split = null;
	private JButton p3Pass = null;
	private JButton p1HitMe = null;
	private JButton p1Pass = null;
	private JButton p3HitMe = null;
	private JButton p2Pass = null;
	private JButton p2HitMe = null;
	private JButton p3Split = null;
	private JTextPane p1Hand = null;
	private JTextPane p1SplitHand = null;
	private JTextPane dealerHand = null;
	private JTextPane p1DisplayAcct = null;
	private JTextPane newGametxt = null;
	private JTextPane p2SplitHand = null;
	private JTextPane p2Hand = null;
	private JTextPane p2DisplayAcct = null;
	private JTextPane p3DisplayAcct = null;
	private JTextPane p3Hand = null;
	private JTextPane p3SplitHand = null;
	private JTextPane scoreNames = null;
	private JTextPane scoreScores = null;
	private JLabel allTimes = null;
	private JButton jButton = null;
	private JButton insure1 = null;
	private JButton insure2 = null;
	private JButton insure3 = null;
	private JButton p1Double = null;
	private JButton p2Double = null;
	private JButton p3Double = null;
	
	// Information text for pop up
	String newline = System.getProperty("line.separator");					
	private String cardInfoDoc = "In order to rig the Deck of cards:" + newline + newline +
								"In the 'Index' filed, enter the card index you want to rig" + newline +
								"(0 = top of deck, 51 = bottom of deck)"+ newline +
								"'Card being read' tells you which card is on top of the deck"+ newline +
								"(i.e. the index next card to be drawn)"  + newline + newline + 
								"In the 'Card #' filed, enter the code of the card you want to place at 'Index'" + newline +
								"Hit 'Show Deck' to peep into all the cards of the deck"+ newline + newline + "Suites are represented by x00" + newline + 
								"Heart = 100    Diamonds = 200    Clubs = 300    Spades = 400" + newline + newline + 
								"Numbers are represented by their values   0xx" + newline + 
								"Special cases: Ace = 1, Jack = 11, Queen = 12, King = 13" + newline + newline + 
								"Examples: " + newline + 
								"Ace of spades = 401      3 of Hear = 103" + newline + 
								"King of spades = 413     Queen of Heart = 112" + newline + newline +
								"NOTE: if you rig the deck, cards WILL NOT BE SHUFFLED at next game, but" + newline + 
								"the card Index will be set back to 0. It becomes YOUR responsibility to set" + newline +
								"all the 'empty' cards!";

	
	// Initializes the deck of cards and shuffles it, players and highScore
	public Cards deckOfCards = new Cards();
	public Dealer dealer = new Dealer();
	public Player player1 = new Player();
	public Player player2 = new Player();
	public Player player3 = new Player();
	public HighScoreRecord records = new HighScoreRecord();

	
	
	// Default table constructor
	public Table() {
		super();
		initialize();
	}

	
	// This method initializes this
	private void initialize() {
		this.setSize(700, 600);
		this.setContentPane(getJDesktopPane());
		this.setTitle("BlackJack Game");
	}
	


	// This method initializes BlackJack table content
	public JDesktopPane getJDesktopPane() {
		if (tableTop == null) {
			// Creating text fields and button objects
			allTimes = new JLabel();
			allTimes.setBounds(new java.awt.Rectangle(507,9,172,15));
			jLabel = new JLabel("Really Cheat");
			jLabel.setBounds(new java.awt.Rectangle(8,34,110,24));
			jLabel6 = new JLabel();
			jLabel6.setBounds(new java.awt.Rectangle(509,215,0,0));
			LabelDealer = new JLabel("DEALER");
			LabelDealer.setBounds(new java.awt.Rectangle(239,11,120,20));
			cardRead = new JLabel("Card being read: " + deckOfCards.cardIndex);
			cardRead.setBounds(new java.awt.Rectangle(8,64,140,17));
			tableTop = new JDesktopPane();
			tableTop.add(getJButton(), null);
			tableTop.add(getJButton1(), null);
			tableTop.add(getJTextField(), null);
			tableTop.add(cardRead, null);
			tableTop.add(getJTextField1(), null);
			tableTop.add(LabelDealer, null);
			tableTop.add(jLabel6, null);
			tableTop.add(getInfoButton(), null);
			tableTop.add(getShowDeckButton(), null);
			tableTop.add(jLabel, null);
			tableTop.add(getJP1name(), null);
			tableTop.add(getJP2Name(), null);
			tableTop.add(getJP3Name(), null);
			tableTop.add(getJButton2(), null);
			tableTop.add(getJButton12(), null);
			tableTop.add(getJButton3(), null);
			tableTop.add(getJButton5(), null);
			tableTop.add(getJButton6(), null);
			tableTop.add(getJButton7(), null);
			tableTop.add(getJButton32(), null);
			tableTop.add(getJButton72(), null);
			tableTop.add(getJButton8(), null);
			tableTop.add(getJTextPane(), null);
			tableTop.add(getJTextPane2(), null);
			tableTop.add(getJTextPane3(), null);
			tableTop.add(getJTextPane4(), null);
			tableTop.add(getJTextPane5(), null);
			tableTop.add(getJTextPane1(), null);
			tableTop.add(getJTextPane22(), null);
			tableTop.add(getJTextPane12(), null);
			tableTop.add(getJTextPane13(), null);
			tableTop.add(getJTextPane14(), null);
			tableTop.add(getJTextPane15(), null);
			tableTop.add(getJButton13(), null);
			tableTop.add(getJButton14(), null);
			tableTop.add(getJButton15(), null);
			tableTop.add(getJTextPane6(), null);
			tableTop.add(getJTextPane16(), null);
			tableTop.add(allTimes, null);
			tableTop.add(getJButton16(), null);
			tableTop.add(getJButton22(), null);
			tableTop.add(getJButton33(), null);
		}
		return tableTop;
	}


	// Methods for game buttons
	
	// RigCards: Takes the card value in Card# field and pouts it in the deck at Index
	private JButton getJButton() {
		if (rigCardButton == null) {
			rigCardButton = new JButton("Rig Card");
			rigCardButton.setBounds(new java.awt.Rectangle(8,113,140,24));
			rigCardButton.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					deckOfCards.setIndexCard(Integer.parseInt(rigCardNumber.getText()), 
											Integer.parseInt(rigCardIndex.getText()));
					deckOfCards.riggedDeck = true;
				}
			});
		}
		return rigCardButton;
	}
	
	// Provides rigCardButton with user entered card #
	private JTextField getJTextField() {
		if (rigCardNumber == null) {
			rigCardNumber = new JTextField("Card #");
			rigCardNumber.setBounds(new java.awt.Rectangle(8,87,55,20));
		}
		return rigCardNumber;
	}

	// Provides rigCardButton with user entered card index
	private JTextField getJTextField1() {
		if (rigCardIndex == null) {
			rigCardIndex = new JTextField("Index");
			rigCardIndex.setBounds(new java.awt.Rectangle(78,87,55,20));
		}
		return rigCardIndex;
	}

	
	// Will generate a new game
	private JButton getJButton1() {
		if (newGameButton == null) {
			newGameButton = new JButton("New Game");
			newGameButton.setBounds(new java.awt.Rectangle(8,6,140,24));
			newGameButton.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					newGame = true;
					gameOver = false;
				}
			});
		}
		return newGameButton;
	}
	
	// Popup window to show content of the deck
	private JButton getShowDeckButton() {
		if (showDeckButton == null) {
			showDeckButton = new JButton("Show Deck");
			showDeckButton.setBounds(new java.awt.Rectangle(8,142,140,24));
			showDeckButton.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					String newline = System.getProperty("line.separator");					
					String showCards = "Index   Card";
				
					// Scan the 52 cards and display index and card
					for (int i = 0; i < 52; i++){
						showCards = showCards + newline + 
						Integer.toString(i) + "     " + deckOfCards.toString(deckOfCards.deck[i]);
					}
					JOptionPane.showMessageDialog(tableTop,showCards);
				}
			});
		}
		return showDeckButton;
	}


	// Info button provides user with information on how to correctly cheat
	public JButton getInfoButton() {
		if (info == null) {
			info = new JButton("?");
			info.setBounds(new java.awt.Rectangle(8,170,60,24));
			info.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
				      JOptionPane.showMessageDialog(tableTop,cardInfoDoc);				}
			});
		}
		return info;
	}

	// Insurance buttons
	private JButton getJButton16() {
		if (insure1 == null) {
			insure1 = new JButton("Insure");
			insure1.setBounds(new java.awt.Rectangle(164,176,100,20));
			insure1.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					if (player1.canInsure && player1.account >= 5){
						player1.canInsure = false;
						player1.account -= 5;
						player1.didInsure = true;
					}
				}
			});
		}
		return insure1;
	}


	private JButton getJButton22() {
		if (insure2 == null) {
			insure2 = new JButton("Insure");
			insure2.setBounds(new java.awt.Rectangle(324,176,100,20));
			insure2.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					if (player2.canInsure && player2.account >= 5){
						player2.canInsure = false;
						player2.account -= 5;
						player2.didInsure = true;
					}				}
			});
		}
		return insure2;
	}


	private JButton getJButton33() {
		if (insure3 == null) {
			insure3 = new JButton("Insure");
			insure3.setBounds(new java.awt.Rectangle(484,176,100,20));
			insure3.setText("Insure");
			insure3.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					if (player3.canInsure && player3.account >= 5){
						player3.canInsure = false;
						player3.account -= 5;
						player3.didInsure = true;
					}				}
			});
		}
		return insure3;
	}





	// Double buttons

	private JButton getJButton13() {
		if (p1Double == null) {
			p1Double = new JButton("Double");
			p1Double.setBounds(new java.awt.Rectangle(164,196,100,20));
			p1Double.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					if(!player1.doubleDown && player1.hand[2] == 0 && player1.account >= 10){
						player1.doubleDown = true;
						player1.getPaid(-10);
						player1.hitHand(deckOfCards.getNextCard());
						player1.canHit = false;
						player1.canHitSplit = false;
						player1.canInsure = false;

					}
				}
			});
		}
		return p1Double;
	}

	private JButton getJButton14() {
		if (p2Double == null) {
			p2Double = new JButton("Double");
			p2Double.setBounds(new java.awt.Rectangle(324,196,100,20));
			p2Double.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					if(!player2.doubleDown && player2.hand[2] == 0 && player2.account >= 10){
						player2.doubleDown = true;
						player2.getPaid(-10);
						player2.hitHand(deckOfCards.getNextCard());
						player2.canHit = false;
						player2.canHitSplit = false;
						player2.canInsure = false;

					}
				}
			});
		}
		return p2Double;
	}


	private JButton getJButton15() {
		if (p3Double == null) {
			p3Double = new JButton("Double");
			p3Double.setBounds(new java.awt.Rectangle(484,196,100,20));
			p3Double.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					if(!player3.doubleDown && player3.hand[2] == 0 && player3.account >= 10){
						player3.doubleDown = true;
						player3.getPaid(-10);
						player3.hitHand(deckOfCards.getNextCard());
						player3.canHit = false;
						player3.canHitSplit = false;
						player3.canInsure = false;

					}
				}
			});
		}
		return p3Double;
	}
	
	
	
	// Split buttons
	private JButton getJButton2() {
		if (p1Split == null) {
			p1Split = new JButton();
			p1Split.setBounds(new java.awt.Rectangle(164,216,100,20));
			p1Split.setText("Split");
			p1Split.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					if (player1.canSplit == true){
						player1.deductAcct();
						player1.splitHand[0] = player1.hand[1];
						player1.hand[1] = 0;
						player1.canSplit = false;
						player1.didSplit=true;
						player1.canInsure = false;

			    		updateGui();
					}
				}
			});
		}
		return p1Split;
	}

	private JButton getJButton12() {
		if (p2Split == null) {
			p2Split = new JButton();
			p2Split.setBounds(new java.awt.Rectangle(324,216,100,20));
			p2Split.setText("Split");
			p2Split.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					if (player2.canSplit == true){
						player2.deductAcct();
						player2.splitHand[0] = player2.hand[1];
						player2.hand[1] = 0;
						player2.canSplit = false;
						player2.didSplit=true;
						player2.canInsure = false;

			    		updateGui();

					}				}
			});
		}
		return p2Split;
	}
	
	private JButton getJButton8() {
		if (p3Split == null) {
			p3Split = new JButton();
			p3Split.setText("Split");
			p3Split.setBounds(new java.awt.Rectangle(484,216,100,20));
			p3Split.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					if (player3.canSplit == true){
						player3.deductAcct();
						player3.splitHand[0] = player3.hand[1];
						player3.hand[1] = 0;
						player3.canSplit = false;
						player3.didSplit=true;
						player3.canInsure = false;

			    		updateGui();

					}
					}
			});
		}
		return p3Split;
	}
	
	
	// Hit Buttons
	private JButton getJButton5() {
		if (p1HitMe == null) {
			p1HitMe = new JButton();
			p1HitMe.setBounds(new java.awt.Rectangle(164,236,100,20));
			p1HitMe.setText("Hit Me");
			p1HitMe.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					// If the player is still hitting the first hand
					// If he is allowed to hit
					if(player1.canHit == true){
						player1.hitHand(deckOfCards.getNextCard());
						// Can't split after first hit
						player1.canSplit = false;
						player1.canInsure = false;
						updateGui();
					}
					
					// otherwise, can hit Split = true
					// Means player is hitting the split hand
					if(player1.canHitSplit == true)
							player1.hitSplitHand(deckOfCards.getNextCard());
	
					updateGui();		
				}
			});
		}
		return p1HitMe;
	}
	
	private JButton getJButton72() {
		if (p2HitMe == null) {
			p2HitMe = new JButton();
			p2HitMe.setBounds(new java.awt.Rectangle(324,236,100,20));
			p2HitMe.setText("Hit Me");
			p2HitMe.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					// If the player is still hitting the first hand
					// If he is allowed to hit
					if(player2.canHit == true){
						player2.hitHand(deckOfCards.getNextCard());
						// Can't split after first hit
						player2.canSplit = false;
						player2.canInsure = false;

						updateGui();
					}
					
					// otherwise, can hit Split = true
					// Means player is hitting the split hand
					if(player2.canHitSplit == true)
							player2.hitSplitHand(deckOfCards.getNextCard());
	
					updateGui();					}
			});
		}
		return p2HitMe;
	}
	private JButton getJButton7() {
		if (p3HitMe == null) {
			p3HitMe = new JButton();
			p3HitMe.setBounds(new java.awt.Rectangle(484,236,100,20));
			p3HitMe.setText("Hit Me");
			p3HitMe.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					// If the player is still hitting the first hand
					// If he is allowed to hit
					if(player3.canHit == true){
						player3.hitHand(deckOfCards.getNextCard());
						// Can't split after first hit
						player3.canSplit = false;
						player3.canInsure = false;

						updateGui();
					}
					
					// otherwise, can hit Split = true
					// Means player is hitting the split hand
					if(player3.canHitSplit == true)
							player3.hitSplitHand(deckOfCards.getNextCard());
	
					updateGui();					}
			});
		}
		return p3HitMe;
	}
	
	
	// Stand buttons
	private JButton getJButton6() {
		if (p1Pass == null) {
			p1Pass = new JButton();
			p1Pass.setBounds(new java.awt.Rectangle(164,256,100,20));
			p1Pass.setText("Stand");
			p1Pass.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					// Player can only hit one hand at a time
					// If he can't hit split, he can disable main hand
					if(player1.canHit == true){
						player1.canSplit = false;				// Can no longer split after a pass
						player1.canHit = false;					// Can no longer hit main hand after a pass
						player1.canInsure = false;
						updateGui();
					}
					// If player 1 is hitting split hand
					if(player1.canHitSplit == true)
						player1.canHitSplit = false;
					
					updateGui();
			}
			});
			
		}
		return p1Pass;
	}

	private JButton getJButton32() {
		if (p2Pass == null) {
			p2Pass = new JButton();
			p2Pass.setBounds(new java.awt.Rectangle(324,256,100,20));
			p2Pass.setText("Stand");
			p2Pass.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					// Player can only hit one hand at a time
					// If he can't hit split, he can disable main hand
					if(player2.canHit == true){
						player2.canSplit = false;				// Can no longer split after a pass
						player2.canHit = false;					// Can no longer hit main hand after a pass
						player2.canInsure = false;
						updateGui();
					}
					// If player 1 is hitting split hand
					if(player2.canHitSplit == true)
						player2.canHitSplit = false;
					
					updateGui();				}
			});
		}
		return p2Pass;
	}
	
	private JButton getJButton3() {
		if (p3Pass == null) {
			p3Pass = new JButton();
			p3Pass.setBounds(new java.awt.Rectangle(484,256,100,20));
			p3Pass.setText("Stand");
			p3Pass.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					// Player can only hit one hand at a time
					// If he can't hit split, he can disable main hand
					if(player3.canHit == true){
						player3.canSplit = false;				// Can no longer split after a pass
						player3.canHit = false;					// Can no longer hit main hand after a pass
						player3.canInsure = false;

						updateGui();
					}
					// If player 1 is hitting split hand
					if(player3.canHitSplit == true)
						player3.canHitSplit = false;
					
					updateGui();
					}
			});
		}
		return p3Pass;
	}


	/**
	 * This method initializes jButton	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getJButton4() {
		if (jButton == null) {
			jButton = new JButton();
			jButton.setBounds(new java.awt.Rectangle(43,244,98,25));
		}
		return jButton;
	}




	
	// Player Name fields
	private JTextField getJP1name() {
		if (p1Name == null) {
			p1Name = new JTextField("P1 Name");
			p1Name.setBounds(new java.awt.Rectangle(164,276,100,20));
		}
		return p1Name;
	}

	private JTextField getJP2Name() {
		if (p2Name == null) {
			p2Name = new JTextField("P2 Name");
			p2Name.setBounds(new java.awt.Rectangle(324,276,100,20));
		}
		return p2Name;
	}

	private JTextField getJP3Name() {
		if (p3Name == null) {
			p3Name = new JTextField("P3 Name");
			p3Name.setBounds(new java.awt.Rectangle(484,276,100,20));
		}
		return p3Name;
	}
	
	// Display Account balance fields
	private JTextPane getJTextPane4() {
		if (p1DisplayAcct == null) {
			p1DisplayAcct = new JTextPane();
			p1DisplayAcct.setBounds(new java.awt.Rectangle(164,296,80,15));
			p1DisplayAcct.setText(Integer.toString(player1.account));
		}
		return p1DisplayAcct;
	}
	
	private JTextPane getJTextPane12() {
		if (p2DisplayAcct == null) {
			p2DisplayAcct = new JTextPane();
			p2DisplayAcct.setBounds(new java.awt.Rectangle(324,296,80,20));
			p2DisplayAcct.setText(Integer.toString(player2.account));

		}
		return p2DisplayAcct;
	}

	private JTextPane getJTextPane13() {
		if (p3DisplayAcct == null) {
			p3DisplayAcct = new JTextPane();
			p3DisplayAcct.setBounds(new java.awt.Rectangle(484,296,80,20));
			p3DisplayAcct.setText(Integer.toString(player3.account));

		}
		return p3DisplayAcct;
	}


	// Main hand field (text content gets generated/refreshed in updateGui();

	private JTextPane getJTextPane() {
		if (p1Hand == null) {
			p1Hand = new JTextPane();
			p1Hand.setBounds(new java.awt.Rectangle(164,316,135,125));
		}
		return p1Hand;
	}
	
	private JTextPane getJTextPane22() {
		if (p2Hand == null) {
			p2Hand = new JTextPane();
			p2Hand.setBounds(new java.awt.Rectangle(324,316,135,125));
		}
		return p2Hand;
	}
	
	private JTextPane getJTextPane14() {
		if (p3Hand == null) {
			p3Hand = new JTextPane();
			p3Hand.setBounds(new java.awt.Rectangle(484,316,135,125));
		}
		return p3Hand;
	}
	
	private JTextPane getJTextPane3() {
		if (dealerHand == null) {
			dealerHand = new JTextPane();
			dealerHand.setBounds(new java.awt.Rectangle(235,49,135,125));
		}
		return dealerHand;
	}

	private JTextPane getJTextPane2() {
		if (p1SplitHand == null) {
			p1SplitHand = new JTextPane();
			p1SplitHand.setBounds(new java.awt.Rectangle(164,441,135,125));
		}
		return p1SplitHand;
	}
	
	private JTextPane getJTextPane1() {
		if (p2SplitHand == null) {
			p2SplitHand = new JTextPane();
			p2SplitHand.setBounds(new java.awt.Rectangle(324,441,135,125));
		}
		return p2SplitHand;
	}

	private JTextPane getJTextPane15() {
		if (p3SplitHand == null) {
			p3SplitHand = new JTextPane();
			p3SplitHand.setBounds(new java.awt.Rectangle(484,441,135,125));
		}
		return p3SplitHand;
	}
	
	// Following text field to warn user that a new game is being prepared
	private JTextPane getJTextPane5() {
		if (newGametxt == null) {
			newGametxt = new JTextPane();
			newGametxt.setBounds(new java.awt.Rectangle(369,12,108,53));
		}
		return newGametxt;
	}

	// High score text fields (names seperated from scores for coding convenience)
	private JTextPane getJTextPane6() {
		if (scoreNames == null) {
			scoreNames = new JTextPane();
			scoreNames.setBounds(new java.awt.Rectangle(500,30,90,130));
		}
		return scoreNames;
	}

	private JTextPane getJTextPane16() {
		if (scoreScores == null) {
			scoreScores = new JTextPane();
			scoreScores.setBounds(new java.awt.Rectangle(590,30,90,130));
		}
		return scoreScores;
	}
	
	
	// Function updateGui()
	// Updates hand content fields, account and backgrounds
	private void updateGui(){

		// Update user cheat pertinent info
		cardRead.setText("Card being read: " + deckOfCards.cardIndex);
		
		// String dealer's hand
		dealerHand.setText(dealer.stringHand(dealer.hand));
		
		// The following script gets duplicated for all players
		// Updates background colors, account balance and hands
		p1DisplayAcct.setText(Integer.toString(player1.account) + "$");
		p1Hand.setText(player1.stringHand(player1.hand));
		p1SplitHand.setText(player1.stringHand(player1.splitHand));
		if(player1.bankrupt){
			p1Hand.setText("BANKRUPT!");
		}

		p2DisplayAcct.setText(Integer.toString(player2.account) + "$");
		p2Hand.setText(player2.stringHand(player2.hand));
		p2SplitHand.setText(player2.stringHand(player2.splitHand));
		if(player2.bankrupt){
			p2Hand.setText("BANKRUPT!");
		}

		p3DisplayAcct.setText(Integer.toString(player3.account) + "$");
		p3Hand.setText(player3.stringHand(player3.hand));
		p3SplitHand.setText(player3.stringHand(player3.splitHand));
		if(player3.bankrupt){
			p3Hand.setText("BANKRUPT!");
		}
		

	}
	
	// Function called at the start of a round
	private void initiatePlayer(Player newPlayer){
		
			newPlayer.resetHand();
			newPlayer.deductAcct();
			newPlayer.hitHand(deckOfCards.getNextCard());
			newPlayer.hitHand(deckOfCards.getNextCard());
			newPlayer.canHit = true;
			newPlayer.didSplit = false;
			newPlayer.canHitSplit = false;
			newPlayer.doubleDown = false;
			newPlayer.canInsure = false;
			newPlayer.didInsure = true;
			updateGui();		
		
	}

	
	
	// Function listens to the buttons regulating the main hand of players
	public void doMainHand(Player player){
		// Detect if player is in condition to split
		if((player.hand[0]%100 == player.hand[1]%100)){
			player.canSplit = true;
		}
		
		// Detect if dealer can insure
		if(dealer.hand[0]%100 == 1)
			player.canInsure = true;
		
		// Offer player to Hit or split on primary hand
		// While in this loop, 'Hit Me' & 'Pass' are listened to by primary hand
		player.canHit = true;
		
		while (player.canHit == true){
		// Break out of the loop if request for a new game 
		if(newGame == true)
				break;
			
		// Set the background to indicate who is playing
		updateGui();
		
		// Put the process to sleep most of the time to wait for human interaction
		try { 
			Thread.sleep(200);
		} catch (Exception e) { }
			
		// Stop hit when player busts (Flag can also be activated with 'Pass' Button
		if (player.getHandValue(player.hand) >= 21){
			player.canHit = false;
		}
		
			
		}
		
	}
	
	
	// Function listens to player buttons but actions applied to applit hand
	public void doSplitHand(Player player){
		
		// Condition to allow split is checked in main()
		player.canHitSplit = true;
		
		while(player.canHitSplit == true){
			
			// Break out of the loop if request for a new game 
			if(newGame == true)
				break;		
			
			updateGui();

			// Put the process to sleep most of the time to wait for human interaction
			try { 
				Thread.sleep(200);
			} catch (Exception e) { }
		
			// Get out if hand is busted
			if (player.getHandValue(player.splitHand) >= 21){
				player.canHitSplit = false;
			}
		}// End of while player can split (Pass button hit or busted 21)
	}// End of doSplitHand
	
	
	
	// Function to determin payouts at the end of rounds
	// Enter with newGame = false, endOfGame = false and player is not bankrupt
	public void doAccounting(Player player){
		boolean doneHand = false;
		boolean doneSplit = true;
		int doubleBet = 1;
		
		if(player.doubleDown)
			doubleBet = 2;
			
		
		updateGui();

		if(player.didSplit)
			doneSplit = false;
		
		// Leave if busted
		if(player.getHandValue(player.hand) > 21)
			doneHand = true;
		
		if(player.didSplit && (player.getHandValue(player.splitHand) > 21))
			doneSplit = true;
		

		// Pay insurance if dealer blackjack
		if(player.didInsure && dealer.getHandValue(dealer.hand) == 21 && dealer.hand[2] == 0 && !doneHand)
			player.account += 10;
		
		// Break even payout
		if(player.getHandValue(player.hand) == dealer.getHandValue(dealer.hand) && !doneHand){
			doneHand = true;
			player.getPaid(doubleBet * 10);
		}
		
		if(player.getHandValue(player.splitHand) == dealer.getHandValue(dealer.hand) && !doneSplit){
			doneSplit = true;
			player.getPaid(10);
		}
		
		// BlackJack payout
		if(player.getHandValue(player.hand) == 21 && player.hand[2] == 0 && !doneHand){
			player.getPaid(doubleBet * 25);
			doneHand = true;
		}
		
		if(player.getHandValue(player.splitHand) == 21 && player.splitHand[2] == 0 && !doneSplit){
			doneSplit = true;
			player.getPaid(25);
		}
		
		// Regular payout
		if(player.getHandValue(player.hand) > dealer.getHandValue(dealer.hand) && !doneHand){
			doneHand = true;
			player.getPaid(doubleBet * 20);		
		}
		
		if(player.getHandValue(player.splitHand) > dealer.getHandValue(dealer.hand) && !doneSplit){
			doneSplit = true;
			player.getPaid(20);
		}
		

		updateGui();
		// Pause for eye candy
		try { 
			Thread.sleep(100);
		} catch (Exception e) { }
			
		// Check for bankrupt condition
		if (player.account < 10)
			player.bankrupt = true;		
	}

	
	
	



	public static void main(String[] args){

		// Create Blackjack table
    	Table table = new Table();
    	table.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
    	table.setVisible(true);

    	// Define custom colors to be used by the GUI
		Color lightGrey = new Color(198,226,255);
		Color white = new Color(255,255,255);
		Color green = new Color(127,255,212);
    	
    	
    	// Deck and players are created inside the table object
		while(true){
			
			// Pause the thread to reduce processing (short enough that user doesn't notice lag)
			try { 
				Thread.sleep(200);
			} catch (Exception e) { };

			// If new game button has been pressed
			if (table.newGame == true){	
				table.newGametxt.setText("Setting Up new Game...");
				// Put the process to sleep so human can read that a new game is starting
				try { 
					Thread.sleep(900);
				} catch (Exception e) { }
				
				table.player1.account = 100;
				table.player2.account = 100;
				table.player3.account = 100;
				table.player1.bankrupt = false;
				table.player2.bankrupt = false;
				table.player3.bankrupt = false;


				
				// If the deck has not been rigged, shuffle the cards
				if(!table.deckOfCards.riggedDeck){
					table.deckOfCards.shuffleDeck();
				}
				
				// Remove flag for next game
				table.deckOfCards.riggedDeck = false;
				table.newGame = false;

				// Weather deck rigged or not, set card index at the top of the deck
				table.deckOfCards.cardIndex = 0;
				table.newGametxt.setText("");
				table.newGametxt.setBackground(white);

			}// End if(newGame)

			
	
			// Reset Dealer and Player's hands
			table.dealer.resetHand();
			table.dealerHand.setBackground(white);
			table.player1.resetHand();
			table.player2.resetHand();
			table.player3.resetHand();
			table.updateGui();
			

			
			// Here the actual game starts
			// Initial deal, account deductions
			if(!table.player1.bankrupt)
				table.initiatePlayer(table.player1);
			if(!table.player2.bankrupt)
				table.initiatePlayer(table.player2);
			if(!table.player3.bankrupt)
				table.initiatePlayer(table.player3);
			
			// Distribute dealer hand
			table.dealer.hitHand(table.deckOfCards.getNextCard());
			table.dealer.canHit = true;
	    	table.updateGui();
			
	    	
	    	// Player 1 game flow (repeated for p2 and p3)
	    	// Play main hand
			if(!table.player1.bankrupt){
				table.p1Hand.setBackground(lightGrey);
				table.doMainHand(table.player1);
			}
	
			table.p1Hand.setBackground(white);
			table.updateGui();

					
			// If player did split when he had a chance, work split hand
			if(table.player1.didSplit && !table.player1.bankrupt) {
				table.p1SplitHand.setBackground(lightGrey);
				table.doSplitHand(table.player1);
			}
			table.p1SplitHand.setBackground(white);	
			table.updateGui();
			
			
			// Player 2
	    	// Play main hand
			if(!table.player2.bankrupt){
				table.p2Hand.setBackground(lightGrey);
				table.doMainHand(table.player2);
			}
	
			table.p2Hand.setBackground(white);
			table.updateGui();

					
			// If player did split when he had a chance, work split hand
			if(table.player2.didSplit && !table.player2.bankrupt) {
				table.p2SplitHand.setBackground(lightGrey);
				table.doSplitHand(table.player2);
			}
			table.p2SplitHand.setBackground(white);	
			table.updateGui();
			
			
			
			
			// Player 3
	    	// Play main hand
			if(!table.player3.bankrupt){	
				table.p3Hand.setBackground(lightGrey);
				table.doMainHand(table.player3);
			}
	
			table.p3Hand.setBackground(white);
			table.updateGui();

					
			// If player did split when he had a chance, work split hand
			if(table.player3.didSplit && !table.player3.bankrupt) {
				table.p3SplitHand.setBackground(lightGrey);
				table.doSplitHand(table.player3);
			}
			table.p3SplitHand.setBackground(white);	
			table.updateGui();

			
			
			
			// Now that all players have passed, do dealer

			while(table.dealer.getHandValue(table.dealer.hand) < 17){
				// Break out of the loop if request for a new game 
				if(table.newGame == true)
					break;
				
				// Ignore loop if game is over
				if(table.gameOver)
					break;
				


				table.dealerHand.setBackground(lightGrey);
				table.updateGui();
				
				// Pause for eye candy
				try { 
					Thread.sleep(500);
				} catch (Exception e) { }
				
				// Hit dealer with a card
				table.dealer.hitHand(table.deckOfCards.getNextCard());

			}
			table.dealerHand.setBackground(white);
			table.updateGui();

			
			
			// Accounting
			// If the players has a winning hand
			if(!table.gameOver && !table.newGame){
				if(!table.player1.bankrupt){
					table.p1DisplayAcct.setBackground(green);
					table.doAccounting(table.player1);
				}
				table.p1DisplayAcct.setBackground(white);

				table.updateGui();
				
				
				if(!table.player2.bankrupt){
					table.p2DisplayAcct.setBackground(green);
					table.doAccounting(table.player2);
				}
				table.p2DisplayAcct.setBackground(white);

				table.updateGui();
				
				
				if(!table.player3.bankrupt){
					table.p3DisplayAcct.setBackground(green);
					table.doAccounting(table.player3);
				}
				table.p3DisplayAcct.setBackground(white);

				table.updateGui();
		
			}// End of doing accounting

			
			
			// Check for game over condition
			if(table.player1.bankrupt && table.player2.bankrupt){
				table.newGametxt.setText("GAME OVER" + table.newline + table.p3Name.getText() + " wins!");
				table.gameOver = true;
				// Set high score
				table.records.insertScore(table.p3Name.getText(), table.player3.account);
				table.updateGui();
			}

			if(table.player1.bankrupt && table.player3.bankrupt){
				table.newGametxt.setText("GAME OVER" + table.newline + table.p2Name.getText() + " wins!");
				// Set high score
				table.records.insertScore(table.p2Name.getText(), table.player2.account);
				table.gameOver = true;
				table.updateGui();
			}

			if(table.player2.bankrupt && table.player3.bankrupt){
				table.newGametxt.setText("GAME OVER" + table.newline + table.p1Name.getText() + " wins!");
				// Set high score
				table.records.insertScore(table.p1Name.getText(), table.player1.account);table.gameOver = true;
				table.updateGui();
			}
			
			
			
			while(table.gameOver && !table.newGame){
				table.newGametxt.setBackground(green);
				table.player1.resetHand();
				table.player2.resetHand();
				table.player3.resetHand();
				table.dealer.resetHand();
				
				// Display high scores
				table.allTimes.setText("ALL TIMES HIGH SCORES");
				table.scoreNames.setText(table.records.stringNames());
				table.scoreScores.setText(table.records.stringScores());


				table.updateGui();
				
				// Pause so we don't overheat the CPU
				try { 
					Thread.sleep(500);
				} catch (Exception e) { }
				
			}
			
			// Once we leave, clear the high scores
			table.allTimes.setText("");
			table.scoreNames.setText("");
			table.scoreScores.setText("");
			
			
						
    }// End while(true)
	}// End Main
} // End class



